/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sessions;

import entities.CompteBancaire;
import java.util.List;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author mbuffa
 */
@Stateless
@LocalBean
public class GestionnaireCompteBancaire {
    @PersistenceContext
    private EntityManager em;

    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method")
    
    public void creerDonneesDeTest() {
        creerUnCompte("Michel Buffa", 1000000);
        creerUnCompte("John Lennon", 4);
        creerUnCompte("Paul Mc Cartney", 25000);
        creerUnCompte("Ringo Starr", 3000);
        creerUnCompte("Geaorges Harrisson", 2000);
    }
    
    public void creerUnCompte(String nom, double solde) {
        CompteBancaire c = new CompteBancaire(nom, solde);
        persist(c);
    }

    public void persist(Object object) {
        em.persist(object);
    }

    public List<CompteBancaire> getAllComptesBancaires() {
        em.clear();
        Query q = em.createQuery("select c from CompteBancaire as c");
        
        List<CompteBancaire> list = q.getResultList();
        for (CompteBancaire c : list) {
            em.refresh(c);
        }
        return list;
    }

    public void deposeArgent(int idCompteDeDepot, double montant) {
        CompteBancaire c = em.find(CompteBancaire.class, idCompteDeDepot);
        // Le compte est "managed" ou "connecté à la base"
        c.depose(montant);
    }

    public void retireArgent(int idCompteDeDepot, double montant) {
       CompteBancaire c = em.find(CompteBancaire.class, idCompteDeDepot);
        // Le compte est "managed" ou "connecté à la base"
        c.retire(montant);
 
    }

    public void transfert(int id1, int id2, double montantTransfert) {
        retireArgent(id1, montantTransfert);
        deposeArgent(id2, montantTransfert);
    }

  
}
